unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    sqsHigh: TSpinEdit;
    sqsWide: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private

  public
    procedure blank(i : integer);
    procedure both;
    procedure down;
    Procedure Across;
  end;

const
  sqSize = 28;
  x = 5;
  y = 50;

var
  Form1: TForm1;
  MouX, MouY  :Integer;  // Used to store a mouse click.
  Boxes : Array [0..21,0..21] of Byte; {This is to store the puzzle square
     definitions.  0=Blank, 1=Across,2=Down,3=Both,4=Addend.}
  d :TPoint;

implementation


{$R *.lfm}

Procedure TForm1.Blank (i : Integer);
  var
    a,b : tpoint;
  Begin
    with paintbox1 do
      begin
        Canvas.Pen.Color:=clRed;

        a.x := (d.x-5) div sqSize;
        a.y := (d.y-50) div sqSize;

        if (a.x in [0..21]) and (a.y in [0..21]) then
          boxes[a.x,a.y] := i
        else
          begin
            showmessage(format('There is an error! a.x=%d; a.y=%d; they should be 0..21',[a.x,a.y]));
            exit;
          end;

        Case i of
          0 : Canvas.Brush.Color:=clBlack;
          4 : Canvas.Brush.Color:=clWhite;
        end;

        Canvas.Pen.Width:=1;

        a.x := x + 1 + SqSize * ((d.X-5)   div SqSize);
        a.y := y + 1 + SqSize * ((d.Y-50)  div SqSize);
        b.x := x +     SqSize * (((d.X-5)  div SqSize)+1);
        b.y := y +     SqSize * (((d.Y-50) div SqSize)+1);
        Canvas.Rectangle(a.x,a.y,b.x,b.y);

        a.x := (d.X-5)   div SqSize;
        a.y := (d.Y-50)  div SqSize;
        Label3.Caption := format('(X,Y)=(%d,%d)',[a.x, a.y]);

        if (a.x in [0..21]) and (a.y in [0..21]) then
          boxes[a.x,a.y] := i
        else
          showmessage(format('There is an error! a.x=%d; a.y=%d; they should be 0..21',[a.x,a.y]));
      end;
  end; // Proc Blank

Procedure TForm1.Both;
  var
    a,b,c : tpoint;
  Begin
    with paintbox1 do
      begin
        Canvas.Pen.Color:=clRed;
        Canvas.Brush.Color:=clWhite;
        Canvas.Pen.Width:=1;

        a.x := x + 1 + SqSize * ((d.X-5)   div SqSize);
        a.y := y + 1 + SqSize * ((d.Y-50)  div SqSize);
        b.x := x +     SqSize * (((d.X-5)  div SqSize)+1);
        b.y := y +     SqSize * (((d.Y-50) div SqSize)+1);
        Canvas.Rectangle(a.x,a.y,b.x,b.y);

        c.x := x + 1 + SqSize * ((d.X-5) div SqSize);
        c.y := y + 1 + SqSize *  (d.Y-5) div SqSize;
        //--------------------------^^ possible typo; maybe should be 50

        Label3.Caption := format('(d.X,d.Y)=(%d,%d)  (X,Y)=(%d,%d)',
                                 [d.X,d.Y, c.x,c.y]);

        Canvas.Pen.Color:=clBlack;
        Canvas.Brush.Color:=clWhite;

        Canvas.Line(a.x,a.y, b.x,b.y);

        a.x := (d.X-5)   div SqSize;
        a.y := (d.Y-50)  div SqSize;

        if (a.x in [0..21]) and (a.y in [0..21]) then
          boxes[a.x,a.y] := 3
        else
          showmessage(format('There is an error! a.x=%d; a.y=%d; they should be 0..21',[a.x,a.y]));
      end;
  end; // Proc Both

Procedure TForm1.Down;
  Var
    m   : Byte;
    a,b,c : tpoint;
  Begin
    with paintbox1 do
      begin
        Canvas.Pen.Color:=clRed;
        Canvas.Brush.Color:=clWhite;
        Canvas.Pen.Width:=1;

        a.x := x + 1 + SqSize * ((d.X-5)   div SqSize);
        a.y := y + 1 + SqSize * ((d.Y-50)  div SqSize);
        b.x := x +     SqSize * (((d.X-5)  div SqSize)+1);
        b.y := y +     SqSize * (((d.Y-50) div SqSize)+1);
        Canvas.Rectangle(a.x,a.y,b.x,b.y);

        c.x := x + 1 + SqSize * ((d.X-5) div SqSize);
        c.y := y + 1 + SqSize *  (d.Y-5) div SqSize;
        //--------------------------^^ possible typo; maybe should be 50
        Label3.Caption := format('(d.X,d.Y)=(%d,%d)  (X,Y)=(%d,%d)',
                                 [d.X,d.Y, c.x,c.y]);

        Canvas.Pen.Color:=clBlack;

        For m := 1 to 28 Do
          Canvas.Line(a.x,a.y, b.x,b.y+m);

        a.x := (d.X-5)   div SqSize;
        a.y := (d.Y-50)  div SqSize;

        if (a.x in [0..21]) and (a.y in [0..21]) then
          boxes[a.x,a.y] := 2
        else
          showmessage(format('There is an error! a.x=%d; a.y=%d; they should be 0..21',[a.x,a.y]));
      end;
  end; // Proc Down

Procedure TForm1.Across;
  Var
    m : Byte;
    a,b,c : tpoint;
  Begin
    with paintbox1 do
      begin
        Canvas.Pen.Color:=clRed;
        Canvas.Brush.Color:=clWhite;
        Canvas.Pen.Width:=1;

        a.x := x + 1 + SqSize * ((d.X-5)   div SqSize);
        a.y := y + 1 + SqSize * ((d.Y-50)  div SqSize);
        b.x := x +     SqSize * (((d.X-5)  div SqSize)+1);
        b.y := y +     SqSize * (((d.Y-50) div SqSize)+1);
        Canvas.Rectangle(a.x,a.y,b.x,b.y);

        c.x := x + 1 + SqSize * ((d.X-5) div SqSize);
        c.y := y + 1 + SqSize *  (d.Y-5) div SqSize;
        //--------------------------^^ possible typo; maybe should be 50
        Label3.Caption := format('(d.X,d.Y)=(%d,%d)  (X,Y)=(%d,%d)',
                                 [d.X,d.Y, c.x,c.y]);

        Canvas.Pen.Color:=clBlack;

        For m := 0 to 27 Do
          Canvas.Line(a.x,a.y+m, b.x,b.y);

        a.x := (d.X-5)   div SqSize;
        a.y := (d.Y-50)  div SqSize;

        if (a.x in [0..21]) and (a.y in [0..21]) then
          boxes[a.x,a.y] := 1
        else
          showmessage(format('There is an error! a.x=%d; a.y=%d; they should be 0..21',[a.x,a.y]));
      end;
  end; //Proc Across


procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  with paintbox1 do
    begin
      Canvas.Pen.Color:=clBlack;
      Canvas.Pen.Width:=3;
      Canvas.Line(0,45,paintbox1.Width,45); //  Black Divider Line.
    end;
end;

procedure TForm1.Button1Click(Sender: TObject); // Makes initial square grid
  Var
    x, j, k : Integer;
    a : tpoint;
  begin
    with paintbox1 do
      begin
        Canvas.Pen.Color:=TColor($f0f0f0);

        For x:=51 to paintbox1.Height Do
          Canvas.Line(0,x,paintbox1.Width,x); //  Clear Canvas with Lines.

        Canvas.Pen.Color:=clBlack;
        Canvas.Pen.Width:=3;

        Canvas.Line(0,45,paintbox1.Width,45); //  Black Divider Line.

        Canvas.Pen.Width:=1;

        a.x := SqsWide.Value * SqSize + 5;
        Canvas.Line(5,50,a.x,50); // First Horz Line.

        For x := 1 to SqsHigh.Value Do
          begin
            a.y := x*SqSize+50;
            Canvas.Line(5,a.y,a.x,a.y); // Horz Lines.
          end;

        a.y := SqsHigh.Value * SqSize + 50;
        Canvas.Line(5,50, 5,a.y); // First Vert Line.

        For x := 1 to SqsWide.Value Do
          begin
            a.x := x * SqSize + 5;
            Canvas.Line(a.x,50, a.x,a.y); // Vert Lines.
          end;

        For j:=0 to 21 Do
          For k:=0 to 21 Do
            Boxes[j,k] := 7;
      end;
  end; // Proc Button1Click Initial Square Grid.

procedure TForm1.Button2Click(Sender: TObject);  // Show Boxes
  Var
    a, b, c, {d,} m,n : Integer;
    s : String;
  begin
    Memo1.Lines.Clear;

    For m := 0 to SqsHigh.Value-1 Do
      Begin
        s:='';
        For n :=0 to SqsWide.Value-1 Do
          s += IntToStr(Boxes[n,m])+',';

        Memo1.Lines.Add(s);
      end;  // m Loop.

    // Looking in Boxes for Accross squares.

    c:=1;
    //d:=0;

    For a := 1 to SqsHigh.Value-1 Do
      For b := 1 to SqsWide.Value-1 Do
        If Boxes[b,a]=1 Then
          While Boxes[b+c,a]=4 Do
            inc(c);
    //----^^^^^^^^^^^^^^^^ this seems pointless

  end; // Proc Button2Click  Show Boxes

procedure TForm1.PaintBox1Click(Sender: TObject);
var
  c : tpoint;
begin
  c := point(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  memo1.append(format('mouse pos = %d,%d',[c.x,c.y]));

  d:=paintbox1.ScreenToClient(c);
  memo1.append(format('translated = %d,%d',[d.x,d.y]));

  // d.X and d.Y are your coordinates
  paintbox1.Canvas.Pen.Width:=1;

  memo1.append(format('ComboBox1.ItemIndex = %d',[ComboBox1.ItemIndex]));
  Case ComboBox1.ItemIndex of
    0 : Blank (ComboBox1.ItemIndex);  // This is a Blank (Non-Playing) Square.
    1 : Across;   // This is a Sum Across Square.
    2 : Down;     // This is a Sum Down Square.
    3 : Both;     // This is a Sum Both Ways Square.
    Else Blank (ComboBox1.ItemIndex); // This is an Addend Square.
  End;
end;

end.

